package ballerina.lang.arrays;

@doc:Description ("Copies the specified double array")
@doc:Param ("doubleArray: The array to be copied" )
@doc:Return ("double[]: A copy of the specified array" )
native function copyOf (double[] doubleArray) (double[]);

@doc:Description ("Returns the length of the specified double array")
@doc:Param ("doubleArray: The double array" )
@doc:Return ("int: The length of the specified array" )
native function length (double[] doubleArray) (int);

@doc:Description ("Copies the specified range of the specified double array ")
@doc:Param ("doubleArray: The double array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("double[]: A new array with the specified range from the original array" )
native function copyOfRange (double[] doubleArray, int from, int to) (double[]);

@doc:Description ("Copies the specified float array")
@doc:Param ("floatArray: The array to be copied" )
@doc:Return ("float[]: A copy of the specified array" )
native function copyOf (float[] floatArray) (float[]);

@doc:Description ("Returns the length of the specified float array")
@doc:Param ("floatArray: The float array" )
@doc:Return ("int: The length of the specified array" )
native function length (float[] floatArray) (int);

@doc:Description ("Copies the specified range of the specified float array ")
@doc:Param ("floatArray: The float array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("float[]: A new array with the specified range from the original array" )
native function copyOfRange (float[] floatArray, int from, int to) (float[]);

@doc:Description ("Copies the specified integer array")
@doc:Param ("intArray: The array to be copied" )
@doc:Return ("int[]: A copy of the specified array" )
native function copyOf (int[] intArray) (int[]);

@doc:Description ("Returns the length of the specified integer array")
@doc:Param ("intArray: The integer array" )
@doc:Return ("int: The length of the specified array" )
native function length (int[] intArray) (int);

@doc:Description ("Copies the specified range of the specified integer array ")
@doc:Param ("intArray: The integer array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("int[]: A new array with the specified range from the original array" )
native function copyOfRange (int[] intArray, int from, int to) (int[]);

@doc:Description ("Copies the specified JSON array")
@doc:Param ("jsonArray: The array to be copied" )
@doc:Return ("json[]: A copy of the specified array" )
native function copyOf (json[] jsonArray) (json[]);

@doc:Description ("Returns the length of the specified JSON array")
@doc:Param ("jsonArray: The JSON array" )
@doc:Return ("int: The length of the specified array" )
native function length (json[] jsonArray) (int);

@doc:Description ("Copies the specified range of the specified JSON array ")
@doc:Param ("jsonArray: The JSON array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("json[]: A new array with the specified range from the original array" )
native function copyOfRange (json[] jsonArray, int from, int to) (json[]);

@doc:Description ("Copies the specified long array")
@doc:Param ("longArray: The array to be copied" )
@doc:Return ("long[]: A copy of the specified array" )
native function copyOf (long[] longArray) (long[]);

@doc:Description ("Returns the length of the specified long array")
@doc:Param ("longArray: The long array" )
@doc:Return ("int: The length of the specified array" )
native function length (long[] longArray) (int);

@doc:Description ("Copies the specified range of the specified long array ")
@doc:Param ("longArray: The long array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("long[]: A new array with the specified range from the original array" )
native function copyOfRange (long[] longArray, int from, int to) (long[]);

@doc:Description ("Copies the specified message object array")
@doc:Param ("messageArray: The array to be copied" )
@doc:Return ("message[]: A copy of the specified array" )
native function copyOf (message[] messageArray) (message[]);

@doc:Description ("Returns the length of the specified message object array")
@doc:Param ("messageArray: The message object array" )
@doc:Return ("int: The length of the specified array" )
native function length (message[] messageArray) (int);

@doc:Description ("Copies the specified range of the specified message object array ")
@doc:Param ("messageArray: The message object array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("message[]: A new array with the specified range from the original array" )
native function copyOfRange (message[] messageArray, int from, int to) (message[]);

@doc:Description ("Copies the specified string array")
@doc:Param ("stringArray: The array to be copied" )
@doc:Return ("string[]: A copy of the specified array" )
native function copyOf (string[] stringArray) (string[]);

@doc:Description ("Returns the length of the specified string array")
@doc:Param ("stringArray: The string array" )
@doc:Return ("int: The length of the specified array" )
native function length (string[] stringArray) (int);

@doc:Description ("Copies the specified range of the specified string array ")
@doc:Param ("stringArray: The string array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("string[]: A new array with the specified range from the original array" )
native function copyOfRange (string[] stringArray, int from, int to) (string[]);

@doc:Description ("Sorts the specified string array ")
@doc:Param ("arr: The string array to be sorted" )
@doc:Return ("string[]): The sorted array" )
native function sort (string[] arr) (string[]);

@doc:Description ("Copies the specified XML array")
@doc:Param ("xmlArray: The XML array to be copied" )
@doc:Return ("xml[]: A copy of the specified array" )
native function copyOf (xml[] xmlArray) (xml[]);

@doc:Description ("Returns the length of the specified XML array")
@doc:Param ("xmlArray: The XML array" )
@doc:Return ("int: The length of the specified array" )
native function length (xml[] xmlArray) (int);

@doc:Description ("Copies the specified range of the specified XML array ")
@doc:Param ("xmlArray: The XML array from which the range will be copied" )
@doc:Param ("from: The initial index of the range" )
@doc:Param ("to: The final index of the range" )
@doc:Return ("xml[]: A new array with the specified range from the original array" )
native function copyOfRange (xml[] xmlArray, int from, int to) (xml[]);

